#ifndef __MCM_H
#define __MCM_H

#if defined(__DLL__)
	#define MCM_API __declspec(dllexport)
#else
	#define MCM_API __declspec(dllimport)
#endif

#include "visa.h"

#if defined(__cplusplus) 
extern "C"
{
#endif

//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_init(ViRsrc VISAaddress);
MCM_API ViStatus _VI_FUNC MCM_close();
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetActivePort(ViInt32 value);
MCM_API ViStatus _VI_FUNC MCM_GetActivePort(ViInt32 *value);
//---------------------------------------------------------------------
#define MCM_ATTR_SeriesLShuntC			0 //
#define MCM_ATTR_ShuntCSeriesL			1 //
#define MCM_ATTR_ShuntLSeriesC			2 //
#define MCM_ATTR_SeriesCShuntL			3 //
#define MCM_ATTR_ShuntLShuntC			4 //
#define MCM_ATTR_SeriesCShuntC			5 //	
#define MCM_ATTR_ShuntCSeriesC			6 //
#define MCM_ATTR_SeriesLShuntL			7 //
#define MCM_ATTR_ShuntLSeriesL			8 //
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetCircuit(ViInt32 value);
MCM_API ViStatus _VI_FUNC MCM_GetCircuit(ViInt32 *value);
//---------------------------------------------------------------------
#define MCM_ATTR_E6						0 //
#define MCM_ATTR_E12					1 //
#define MCM_ATTR_E24					2 //
#define MCM_ATTR_Smooth					3 //
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetSmoothing(ViInt32 value);
MCM_API ViStatus _VI_FUNC MCM_GetSmoothing(ViInt32 *value);
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetRLCGValues(ViReal64 R, ViReal64 L, ViReal64 C, ViReal64 G);
MCM_API ViStatus _VI_FUNC MCM_GetRLCGValues(ViReal64 *R, ViReal64 *L, ViReal64 *C, ViReal64 *G);
MCM_API ViStatus _VI_FUNC MCM_SetL1R1L2R2Values(ViReal64 L1, ViReal64 R1, ViReal64 L2, ViReal64 R2);
MCM_API ViStatus _VI_FUNC MCM_GetL1R1L2R2Values(ViReal64 *L1, ViReal64 *R1, ViReal64 *L2, ViReal64 *R2);
MCM_API ViStatus _VI_FUNC MCM_SetC1G1C2G2Values(ViReal64 C1, ViReal64 G1, ViReal64 C2, ViReal64 G2);
MCM_API ViStatus _VI_FUNC MCM_GetC1G1C2G2Values(ViReal64 *C1, ViReal64 *G1, ViReal64 *C2, ViReal64 *G2);
MCM_API ViStatus _VI_FUNC MCM_ResetValues();
//---------------------------------------------------------------------
#define MCM_ATTR_Embed					0 //
#define MCM_ATTR_Deembed				1 //
#define MCM_ATTR_None					2 //
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetAction(ViInt32 value);
MCM_API ViStatus _VI_FUNC MCM_GetAction(ViInt32 *value);
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetS2PFilePath(ViConstString value);
MCM_API ViStatus _VI_FUNC MCM_GetS2PFilePath(ViInt32 bufferSize, ViChar value[]);
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetS2PFilePrefix(ViConstString value);
MCM_API ViStatus _VI_FUNC MCM_GetS2PFilePrefix(ViInt32 bufferSize, ViChar value[]);
//---------------------------------------------------------------------
MCM_API ViStatus _VI_FUNC MCM_SetApplyImmediate(ViBoolean value);
MCM_API ViStatus _VI_FUNC MCM_GetApplyImmediate(ViBoolean *value);
MCM_API ViStatus _VI_FUNC MCM_ApplyChanges();

// "Appendix 2. Error Codes" from SxVNA_SCPI_Programming_Manual.pdf = _VI_ERROR+ERROR_CODES
#define MCM_ERROR_CMD_ERROR       (_VI_ERROR+0x100) 
#define MCM_ERROR_QUERY_ERROR     (_VI_ERROR+0x400) 

#if defined(__cplusplus)
}
#endif

#endif //__MCM_H